package view;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.IOException;
import java.io.InputStream;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.UIManager;
import org.jb2011.lnf.beautyeye.BeautyEyeLNFHelper;
import chrriis.common.UIUtils;
import chrriis.dj.nativeswing.swtimpl.NativeInterface;

public class PencilMain extends JFrame{
	private static final long serialVersionUID = 1L;
	public static final int COLUM = 34;
	public JDesktopPane desktopPane;	//多文档窗体容器
	public static boolean dbControl = true;	//sqlite数据库只支持一写多读，false=>正在处理大量的写数据。
	private SendEmailFrame sendEmailFrame;	//发送邮箱界面
	private PencilMain _this;
	public static int frameWidth,frameHeight;	//屏幕宽高
	public static int showWidth,showHeight;
	public static String[] DEFAULT_FONT  = new String[]{
		    "CheckBox.font",
		    "ScrollPane.font",
		    "ToolTip.font",
		    "EditorPane.font",
		    "RadioButton.font",
		    "CheckBoxMenuItem.font",
		    "TextPane.font",
		    "TextField.font",
		    "TitledBorder.font",
		    "Label.font",
		    "PasswordField.font",
		};
	public static String[] MID_FONT = new String[]{
			"Menu.font",
			"List.font", 
			"Table.font",
			"Button.font",
			"ComboBox.font",
		    "MenuItem.font",
			"PopupMenu.font",
			"ProgressBar.font", 
	};
	public PencilMain() throws Exception{
    	initFrame();
    }

	@SuppressWarnings("serial")
	public void initFrame() throws Exception{
		_this = this;
		setTitle("校友管理系统");
		desktopPane = new JDesktopPane(){
			protected void paintComponent(Graphics g) {  
		        ImageIcon img = new ImageIcon("resource/img/matebg.png");
		        g.drawImage(img.getImage(), 0, 0, getWidth(), getHeight(), img.getImageObserver());
		    }
		};
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        frameWidth= (int) screenSize.getWidth();
        frameHeight= (int) screenSize.getHeight();
        add(desktopPane);
        setBounds(0,0,frameWidth*3/4,frameHeight*3/4);
		setVisible(true);
		setLocationRelativeTo(null); 
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
		
	public static void main(String[] args) throws Exception{
        try
        {
        	for (int i = 0; i < DEFAULT_FONT.length; i++)
        	    UIManager.put(DEFAULT_FONT[i],new Font("微软雅黑", Font.PLAIN,14));
        	for(int i=0;i<MID_FONT.length;i++)
        		UIManager.put(MID_FONT[i],new Font("微软雅黑", Font.PLAIN,13));
        	UIManager.put("RootPane.setupButtonVisible", false);
        	BeautyEyeLNFHelper.frameBorderStyle = BeautyEyeLNFHelper.FrameBorderStyle.osLookAndFeelDecorated;
        	BeautyEyeLNFHelper.translucencyAtFrameInactive = false;
        	org.jb2011.lnf.beautyeye.BeautyEyeLNFHelper.launchBeautyEyeLNF();
        }catch (Exception e){
        	e.printStackTrace();
        }
        PencilMain pencil = new PencilMain();
        pencil.sendEmail();
	}
	
	public void sendEmail(){
		UIUtils.setPreferredLookAndFeel();   
		if(!NativeInterface.isOpen()){
			NativeInterface.initialize();
			NativeInterface.open();  
		}
        EventQueue.invokeLater(new Runnable() {  
            public void run() {  
                try {  
                	if(sendEmailFrame==null||sendEmailFrame.isClosed()){
	                	sendEmailFrame = new SendEmailFrame(_this);
	                	desktopPane.add(sendEmailFrame);
                	}
                	sendEmailFrame.setMaximum(true);
            		sendEmailFrame.toFront();
                } catch (Exception e) {  
                    e.printStackTrace();  
                }  
            }  
        });  
        //介绍网站https://sourceforge.net/p/djproject/discussion/671154/thread/e813001e/
        //NativeInterface.runEventPump();  
	}
	
}
